package com.test.client;

import java.util.List;
import java.util.ArrayList;

import javax.persistence.*;

import com.test.entities.CustInventory;
import com.test.entities.Customer;

/**
 * @author <a href="mailto:rajbirsb@gmail.com">Rajbir Singh</a>
 * @version $Revision$, $Date$, $Author$
 * @since May 16, 2008
 */
public class Client
{
    private EntityManagerFactory emf;

    public static void main(String[] args)
    {
        Client client = new Client();

        client.createEMF();

        //persist entities with one EM
        client.persistEntities();

        //find an entity using another EM
        client.findEntities();

        client.closeEMF();
    }

    private void createEMF()
    {
        emf = Persistence.createEntityManagerFactory("pu1"); 
    }

    private void closeEMF()
    {
        emf.close();
    }

    public void persistEntities() {
        EntityManager em = emf.createEntityManager();

        em.getTransaction().begin();

        Customer customer = new Customer();
        customer.setIdNumber(1);
        customer.setName("entity1");
        em.persist(customer);

        CustInventory inventory = new CustInventory();
        inventory.setIdNumber(100);
        inventory.setName("inventory1");
        em.persist(inventory);

        List<CustInventory> inventories = new ArrayList<CustInventory>();
        inventories.add(inventory);

        customer.setInventories(inventories);
        inventory.setCustomer(customer);

        em.getTransaction().commit();

        em.close();
    }

    public void findEntities()
    {
        EntityManager em = emf.createEntityManager();

        em.getTransaction().begin();

        Customer cust = em.find(Customer.class, 1);
        System.out.println("cust = " + cust);

        em.getTransaction().commit();

        em.close();
    }
}
